#!/usr/bin/python
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'server.py'                                                 #
#    is part of 'SPyDI: Simple Python Distributed Indexing'                #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import SPyDI
import SPyDI.Application as App

config = App.ConfigTemplate("/home/sadit/3kong/SPyDI")
config.repository_options['poolSize'] = 20
config.name_AppendDocument = 'AppendDocument'
config.TemplatePath.append("/home/sadit/3kong/SPyDI/templates/")
config.DefaultTemplate = "affairstemplate"
config.LanguagePath.append("/home/sadit/3kong/SPyDI/lang/")
if __name__ == '__main__':
    import os, sys
    import threadutils
    import warn
    import sre

    if config.usePsyco:
        try:
            pass
            # import psyco
            #psyco.profile()
        except:
            warn.debug("The psyco module is not present, running without it")

    from AppendDocument import AppendDocument
    app = App.MonolithicApplication(config)
    
    try:
        app.init()
        app.spyro.setobj("AppendDocument", AppendDocument(app.repository, app.realindex))
        app.run()
        app.close()
    except:
        warn.warn()
        app.close()
