#!/usr/bin/python
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'server.py'                                                 #
#    is part of 'SPyDI: Simple Python Distributed Indexing'                #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import os, sys
import config
sys.path.insert(0,os.path.dirname(os.path.dirname(sys.path[0])))
import cgi
import session
import SPyRO as spyro
#import HTTPServer
import httpserver
import Template
from Sendmail import Sendmail
import socket
import warn as debug
from Harvest import Harvest
from threadutils import ServerInThread
import distributor
#import spydihub, spydiidx
import spydihub, spydex
from Repository import Repository
import warn
import Crawler
import sre

try:
    import psyco
    psyco.profile()
except:
    print sys.stderr, "The psyco module is not present"

distindexer = distrepository = idxctl = index = None
distcallback = distrepository = repository = harvest = None
serv = auth = user = sendmail = temp = mesgcache = None
crawler = None

def crawler_init():
    global harvest, distcallback
    crawler = Crawler.Crawler(harvest)
    distcallback.register(crawler, None)

def crawler_close():
    pass

def indexer_close():
    global distindexer, idxctl, index
    distindexer.close()
    index.close()
    idxctl.close()

def indexer_init():
    global distcallback, distindexer, distrepository, idxctl, serv, index
    distindexer = distributor.Random(spread=True)
    idxctl = spydihub.IdxControl(distindexer, 4)
    distcallback.register(idxctl, None)
    serv.server.setobj('index',idxctl)
    #index = spydiidx.DocumentIndexer(basename, poolSize=4,
    #                                 distrepository = distrepository)
    index = spydex.spydex(basename = config.indexdir,
                          cachesize = 128 << 20,
                          poolSize = 4,
                          distrepository = distrepository)
 
    serv.server.setobj('realindex',index)
    idxctl.regindexer(index)

def harvest_close():
    global distcallback, distrepository, repository, harvest
    distcallback.close()
    distrepository.close()
    repository.close()
    harvest.close()

def harvest_init():
    global distcallback, distrepository, repository, harvest
    distcallback = distributor.Random(spread=True, poolSize=4)
    #distrepository = distributor.Random(spread=True, poolSize=4)
    distrepository = distributor.Dummy()
    repository = Repository(config.Repository_Path, distcallback, mode=0600,
                            poolSize=30)
    distrepository.register(repository, None)
    harvest = Harvest(distrepository,harvestEvery=20, harvestCounterTime=10)
    distcallback.register(harvest, None)
    serv.server.setobj('HarvestCallback', distcallback)
    serv.server.setobj('RepositoryDistributor', distrepository)
    serv.server.setobj('Repository', repository)
    serv.server.setobj('Harvest', harvest)

def global_close():
    global serv, auth, user, sendmail, temp, mesgcache
    user.close()
    auth.close()
    sendmail.close()
    serv.close()

def global_init():
    global serv, auth, user, sendmail, temp, mesgcache
    serv=ServerInThread(spyro.CommunicationServer, config.SPyRO_Server)
    auth=session.Authority(config.AuthentityFile)
    user=session.User(config.PasswordFile)
    sendmail=Sendmail(config.SMTP_Server, config.SMTP_Port,
                      config.SpoolMailFile)
    serv.server.setobj('Sendmail', sendmail)
    serv.server.setobj('Authority', auth)
    serv.server.setobj('Passwd', user)

    temp=Template.TemplateCache(config.TemplateDirectory)
    mesgcache=Template.LanguageCache(config.LanguageDirectory)
    serv.server.setobj('TemplateCache',temp)
    serv.server.setobj('LanguageCache',mesgcache)

def dummymain():
    pass

def demonio():
    import os
    try:
        child = os.fork()
        if child > 0:
            print >>sys.stderr, "Sirviendo en PID ", child
            sys.exit(0)
    except OSError, e:
        print >>sys.stderr, "Fork: %d (%s)" % (e.errno, e.strerror)
        sys.exit(1)

    os.chdir(os.getcwd())
    os.setsid()
    os.umask(0)
    sys.stderr = open("spydi_stderr.log","wb+")
    sys.stdout = open("spydi_stdout.log","wb+")
    sys.stdin  = open("/dev/null","rb")

#demonio()
httpd = None
try:
    global_init()
    harvest_init()
    #crawler_init()
    indexer_init()
    if config.Run_HTTP:
        #httpd = HTTPServer.makenew(config.HTTP_Root, config.HTTP_Port,
        #                           Handlers={'/html':config.HTTP_WeyPath})
        httpd = httpserver.sHTTP(('0.0.0.0',config.HTTP_Port),config.HTTP_Root)
        httpd.serve_forever()
    else:
        time.sleep(1<<30 | ((1<<30)-1))
except Exception, e:
    debug.warn("Closing server because ",e)
    # because HTTPServer changes os.chdir
    os.chdir(config.root)
    warn.warn(e)
    try:
        indexer_close()
    except:
        warn.warn()
    try:
        #crawler_close()
        pass
    except:
        warn.warn()
    try:
        harvest_close()
    except:
        warn.warn()
    try:
        global_close()
    except:
        warn.warn()
    #if httpd: httpd.close()
