#!/usr/bin/python
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'server.py'                                                 #
#    is part of 'SPyDI: Simple Python Distributed Indexing'                #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################


import sre
import SPyDI
import SPyDI.Application as App
#from news import extractnews

#def extract_news_filter(site, data):
#    return extractnews.Analizer(data).parse()

import news_sites
valid_sites = news_sites.news_sites.values()

remove_phpsessid = sre.compile(r"&?PHPSESSID=[\d\w]*&?")
def crawler_validator(parser, url):
    for v in valid_sites:
        if url.startswith(v):
            return remove_phpsessid.sub("",url)
    return None
    

def stemmer_function(word):
    l = len(word)    
    for suf,suf2 in (("amiento",'o'),("omiento","o"),('es',''),('a','o'),('ado','o'),('ido','i'),('ando','o'),('endo','e')):
        if word.endswith(suf):
            word = word[:-len(suf)] + suf2
    try:
        if word[-1] == 's':
            word = word[:-2]
        if word[-1] == 'r':
                word = word[:-1]
    except:
        pass
    return word

config = App.ConfigTemplate("/home/sadit/3kong/SPyDI")
config.TemplatePath.append("/home/sadit/3kong/SPyDI/templates/")
config.LanguagePath.append("/home/sadit/3kong/SPyDI/lang/")
config.repository_options['poolSize'] = 10
config.crawler_options['validator'] = crawler_validator
config.realindex_options['stemmer'] = stemmer_function
config.realindex_options['cachesize'] = 8 << 20

config.name_AppendDocument = 'AppendDocument'
config.DefaultTemplate = 'newstemplate'

if __name__ == '__main__':
    import os, sys
    import threadutils
    import warn
    import sre

    if config.usePsyco:
        try:
	    pass
            #import psyco
            #psyco.profile()
        except:
            warn.debug("The psyco module is not present, running without it")

    from AppendDocument import AppendDocument
    app = App.MonolithicApplication(config)
    
    try:
        app.init()
        app.spyro.setobj("AppendDocument", AppendDocument(app.repository, app.realindex))
        app.run()
        app.close()
    except:
        warn.warn()
        app.close()
