#!/usr/bin/python
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'Ontology.py'
#    is part of 'SPyDI: Simple Python Distributed Indexing'                #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from xml.dom.ext.reader import Sax2 as xmlparser
#from xml.dom.ext.reader import PyExpat as xmlparser
#from xml.parsers import xmlproc
import sys
from sys import argv
import xml.dom  
from xml.dom.ext import PrettyPrint as xmlprint
from xml.dom.NodeIterator import NodeIterator
from xml.dom.NodeFilter import NodeFilter

import xml.sax as parserFactory
import xml.dom.NodeFilter
from xml.dom.NodeFilter import NodeFilter

#from xml.sax.sax2exts import XMLValParserFactory as parserFactory
from xml.sax.handler import feature_namespaces, feature_validation
import sre
import warn

import SPyRO
from StringIO import StringIO
import urllib

#comm = SPyRO.CommunicationClientThreaded(config.SPyRO_Server,"/SPyRO?PICKLE2",)
#Harvest = SPyRO.RemoteObject(comm,'Harvest')

_SPACES = sre.compile("^\s+$")
_PUNTOCOMA = sre.compile("\s*;\s*")
class CiteseerOAI:
    def __init__(self):
        pass

    def preparetoindex(self, path, is_string=None):
        parser = parserFactory.make_parser()
        parser.setFeature(feature_namespaces, 1)
        reader=xmlparser.Reader(validate=0, parser=parser)
        doc = None
        try:
            if is_string:
                doc=reader.fromString(path)
            else:
                doc=reader.fromStream(path)
        except Exception, e:
            warn.warn(e)
            return
        walker=doc.createTreeWalker(doc._get_documentElement(),
                   NodeFilter.SHOW_ELEMENT|NodeFilter.SHOW_TEXT, None, 0)
        i = walker.firstChild()
        name = None
        #skip=sre.compile(r'oai_citeseer:relation|oai_citeseer:uri|dc:rights')
        keywords = []
        cites = []
        description = ""
        for node in walker:
            if node._get_nodeType() == node.ELEMENT_NODE:
                name=node._get_nodeName()
                if name.startswith("dc:"): name = name[3:]
            else:
                #print dir(node)
                data = node._get_nodeValue()
		if _SPACES.match(data): continue
                if not name: continue
                #if name == 'dc:source': Harvest.regurl(data)
                if name == 'description':
                    description = str(data)
                    continue
                if name == 'subject':
                    continue
                if name == 'identifier':
                    cites.append(data)
                    keywords.append(data)
                    continue
                if name == 'setSpec':
                    continue
                if name == 'oai_citeseer:uri':
                    cites.append(data[4:])
                    continue
                if name == 'affiliation':
                    for k in _PUNTOCOMA.split(data):
                        if k == 'and': continue
                        keywords.append('affiliation:' + urllib.quote(k))
                else:
                    keywords.append(name + ":" + urllib.quote(data))
        return description, keywords, cites

if __name__ == '__main__':
	oai = CiteseerOAI(None)
	desc, keys = oai.preparetoindex("Hola", "/home/sadit/xml/oai_citeseer1-25.xml")
        print desc
