#include <query.h>
#include <list_node.h>
#include <skip_list.h>
#include <boolean_model.h>

int boolean_model_cmp(void *in_skip_list, void *new_data)
{
  //list_head *in_list = (list_head *)in_skip_list;
  //Siempre existe al menos un nodo para que la lista exista en el skiplist
  //return -id_doc_cmp((id_doc_t *)in_list->first->ld_vpointer, (id_doc_t *)new_data);
  return id_doc_cmp((id_doc_t *)in_skip_list, (id_doc_t *)new_data);
}

/*
void* boolean_model_dup(void *in_skip_list, void *new_data)
{
  list_head *to_insert = (list_head *) new_data;
  list_head_push_vpointer((list_head *) in_skip_list, to_insert->first->ld_vpointer, NULL);
  list_head_free(to_insert, 1);
  return in_skip_list;
}*/

void boolean_model_get_info(query_result *res, void *data,
			    id_doc_t **id_doc, float *sim)
{
  //*id_doc = (id_doc_t *)((list_head *) data)->first->ld_vpointer;
  *id_doc = (id_doc_t *)data;
  *sim = 1.0f;
}

query_result* boolean_model_and(query *q, int begin, int count)
{
  int i, j, total, sigue;
  iterator *itr;
  id_doc_t dmax, *pdoc;
  query_result *res;
  total = begin + count;
  sigue = 1;
  /*query_reset(q);*/
  query_result_new(&res, count, boolean_model_get_info, boolean_model_cmp,
		   NULL);
  for (i = 0; i < total && sigue; i++) {
  query_booleanAND_reset:
    dmax = query_get_max(q);
    /* for: encuentra el mayor y lo pone en todos */
    for (j = 0; j < q->argc && sigue; j++) {
      itr = q->itrs[j];
      /* busca */
      if (!itr) goto boolean_model_and_return_label;
      if (itr->find_forward(itr, &dmax, idx_man_doc_find_cmp) == 0) {
	/* no encontrado, preguntando si se puede seguir */
	if (itr->has_next(itr) == 0) return res;
	goto query_booleanAND_reset;
      }
      if (itr->has_next(itr)) {
	itr->next(itr);
      } else {
	sigue = 0;
      }
    }
    if (i < begin) continue;
    /* Si llego aqui deben recolectarse los documentos */
    pdoc = struct_malloc(id_doc_t);
    *pdoc = dmax;
    res->push(res, pdoc);
  }
boolean_model_and_return_label:
  return res;
}

query_result* boolean_model_or(query *q, int begin, int count)
{
  int i, j, total, any;
  iterator *itr;
  id_doc_t dmin, *pdoc;
  query_result *res;
  total = begin + count;
  /*query_reset(q);*/
  query_result_new(&res, count, boolean_model_get_info, boolean_model_cmp,
		   NULL);
  for (i = 0; i < total; i++) {
    any = 0;
    dmin = query_get_min(q);
    /* for: Si el elemento actual es el menor lo quita  */
    for (j = 0; j < q->argc; j++) {
      itr = q->itrs[j];
      if (!itr || idx_man_doc_find_cmp(itr->current(itr), &dmin)) continue;
      any = 1;
      if (itr->has_next(itr)) {
	itr->next(itr);
      } else {
	q->itrs[j] = NULL;
      }
    }
    /* Si llego aqui deben recolectarse los documentos */
    if (any == 0) return res;
    if (i < begin) continue;
    pdoc = struct_malloc(id_doc_t);
    *pdoc = dmin;
    res->push(res, pdoc);
  }
  return res;
}


