#ifndef _H_BTREE_X_
#define _H_BTREE_X_

#include <cache1.h>
#include <alist.h>
#include <pthread.h>

class btree_head {
public:
  index_t iroot; /* Nodo raiz */
  u_int16_t maximum_pairs; /* Mximo nmero de hijos, factor de ramaje */
  u_int8_t height; /* Altura del rbol */
  index_t ideleted; /* Lista de elementos borrados */
} __attribute__ ((__packed__));

template <T, number_links>
class btree_page {
  u_int16_t elements : 15; /* Nmero de elementos en el nodo */
  u_int16_t external : 1; /* El nodo es interno o externo */
  T data_array[number_links-1];
  index_t links[number_links];
} __attribute__ ((__packed__));

template <T, number_links>
class btree_leaf: private btree_page<T, number_links> {
  index_t iprev;
  index_t inext;
} _attribute__ ((__packed__));

class btree {
  alist *headlist;
  alist *nodelist;
  pthread_mutex_t mutex;
  index_t ihead;
  btree_head *head;
  btree_page *root;
  int (*cmp)(btree * b3, index_t *new_value, index_t *in_tree);
  int (*dup)(btree * b3, int x, int y);
  void *arg; /* Argumento para enviar a las funciones */
};

#endif
