#include <stdio.h>
#include <stdlib.h>

#define OFFSET 1
int get_index(char c, int extend)
{
  int base;
  /* letras: maysculas = minsculas */
  if (c >= 97 && c <= 122) return c - 97 + OFFSET; /* 25 letras */
  if (c >= 65 && c <=  90) return c - 65 + OFFSET;
  /* nmeros */
  if (c >= 48 && c <= 57) return c - 22 + OFFSET; /* 48 - 26 = 22 */
  /* 25 + 10 = 35 */
  switch (c) {
  case '':
  case '':
  case '':
  case '':
  case '':
  case '': return get_index('A',extend);
  case '':
  case '':
  case '':
  case '':
  case '':
  case '': return get_index('E',extend);
  case '':
  case '':
  case '':
  case '':
  case '':
  case '': return get_index('I',extend);
  case '':
  case '':
  case '':
  case '':
  case '':
  case '': return get_index('O',extend);
  case '':
  case '':
  case '':
  case '':
  case '':
  case '': return get_index('U',extend);
  case '':
  case '': return 36 + OFFSET;
  }
  if (c == '') return 37 + OFFSET;
  base = 38 + OFFSET;
  
  switch(c) {
  case 1: return 0;
  case ':': return base + 0;
  case '.': return base + 1;
  }
  if (extend) {
    switch(c) {
    case '/': return base + 2;
    case '@': return base + 3;
    case '.': return base + 4;
    case '(': return base + 5;
    case ')': return base + 6;
    case '-': return base + 7;
    case '_': return base + 8;
    case '+': return base + 9;
    case '~': return base +10;
    }
  }
  return -1;
}

int main_normal()
{
  int inverso[256];
  int i, max,tmp;
  FILE *cfile, *hfile;
  hfile = fopen("alfabeto.h","w");
  cfile = fopen("alfabeto.c","w");
  if (hfile == NULL || cfile == NULL) {
    perror("fopen alfabeto.X");
    exit(1);
  }
  fprintf(hfile,"#ifndef _H_ALFABETO_\n");
  fprintf(hfile,"#define _H_ALFABETO_\n");
  fprintf(cfile,"#include <alfabeto.h>\n");
  fprintf(cfile,"int ENCODING_TABLE[%d] = {\n",256);
  max = -1000000;
  for(i = 0; i < 256; i++) inverso[i] = -1;
  for(i = 0; i < 256; i++) {
    tmp = get_index((char)i,0);
    if (tmp > -1 && inverso[tmp] == -1) inverso[tmp] = i;
    if (max < tmp) max = tmp;
    fprintf(cfile,"\t%d%s /* %d */\n", tmp, (i == 255) ? "" : ",",i);
  }
  fprintf(cfile, "};\n");

  max++;
  fprintf(cfile, "int DECODING_TABLE[%d] = {\n",max);
  for(i = 0; i < max; i++) {
    fprintf(cfile,"\t%d%s /* %d */\n", inverso[i], (i == max-1)? "" : ",",i);
  }
  fprintf(cfile,"};\n");
  fprintf(hfile,"extern int ENCODING_TABLE[%d];\n",256);
  fprintf(hfile,"extern int DECODING_TABLE[%d];\n",max);
  fprintf(hfile,"#define LONGITUD_ALFABETO %d\n",max);
  fprintf(hfile,"#define alfa_get_index_by_char(_c) ENCODING_TABLE[(unsigned char)_c]\n");
  fprintf(hfile,"#define alfa_get_char_by_index(_i) DECODING_TABLE[_i]\n");
  
  fprintf(cfile,"int ENCODING_TABLE_FILES[%d] = {\n",256);
  max = -1000000;
  for(i = 0; i < 256; i++) {
    tmp = get_index((char)i,1);
    if (tmp > -1 && inverso[tmp] == -1) inverso[tmp] = i;
    if (max < tmp) max = tmp;
    fprintf(cfile,"\t%d%s /* %d */\n", tmp, (i == 255) ? "" : ",",i);
  }
  fprintf(cfile, "};\n");

  max++;
  fprintf(cfile, "int DECODING_TABLE_FILES[%d] = {\n",max);
  for(i = 0; i < max; i++) {
    fprintf(cfile,"\t%d%s /* %d */\n", inverso[i], ((i == max-1) ? "" : ","), i);
  }
  fprintf(cfile,"};\n");
  fprintf(hfile,"extern int ENCODING_TABLE_FILES[%d];\n",256);
  fprintf(hfile,"extern int DECODING_TABLE_FILES[%d];\n",max);
  fprintf(hfile,"#define LONG_ALFA_FILES %d\n",max);
  fprintf(hfile,"#define alfaweb_get_index_by_char(_c) ENCODING_TABLE_FILES[(unsigned char)_c]\n");
  fprintf(hfile,"#define alfaweb_get_char_by_index(_i) DECODING_TABLE_FILES[_i]\n");
  fprintf(hfile,"#endif\n");
  fclose(cfile);
  fclose(hfile);
  return 0;
}

int main()
{
  return main_normal();
}
