#ifndef _H_ID_DOC_T_
#define _H_ID_DOC_T_

#include <sys/types.h>

/* Tamao de estructura ligado a index_t */
struct id_doc_t {
/*   unsigned int major: 24;/\* Informacin de documento *\/ */
/*   unsigned int minor: 6; /\* Informacin de Tags (64 diferentes tags) *\/ */
/*   unsigned int flags: 2; /\* Compatibilidad con id_index_t *\/ */
  unsigned int major: 32;/* Informacin de documento */
  unsigned int minor: 6; /* Informacin de Tags (64 diferentes tags) */
  unsigned int flags: 2; /* Compatibilidad con id_index_t */
} __attribute__ ((__packed__));

#define ID_DOC_MINOR_MAX 63


typedef struct id_doc_t id_doc_t;

/* Compara dos id_doc_t a y b. Resgresa:
   a = b: regresa cero
   a > b: regresa positivo
   a < b: regresa negativo
 */
int id_doc_cmp(const id_doc_t *a, const id_doc_t *b);
/* Igual a id_doc_cmp pero solo compara |major| para cada id_doc_t */
int id_doc_cmp_major(const id_doc_t *a, const id_doc_t *b);
/* Imprime el major y el minor del documento */
void id_doc_print(const id_doc_t *a, const char *str);
#endif
