#include <trie_node.h>
#include <text_trie.h>
#include <alfabeto.h>
#include <stdlib.h>
#include <errno.h>
#include <cache1.h>
#include <idx_man.h>
#include <pthread.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <alist.h>
#include <stdio.h>

int get_random(int max)
{
  return (int)(drand48()*max);
}

#define max 1100000
#define CACHE_SIZE 0
/*#define CACHE_SIZE sizeof(int)*64*/
#define NOMBRE "a1-cache"
index_t array[max];
int main(int argc, char **argv)
{
  FILE *output;
  int i,j, *data, mult;
  index_t head;
  cache1 *cache;
  alist * list;
  iterator *itr;
  srand48(time(NULL));
  output = fopen("output.log","w");
  unlink(NOMBRE);
  switch(cache1_open(&cache, NOMBRE, 0640, 0, 1<<16, CACHE_SIZE)) {
  case CACHE1_CREATED:
    fprintf(stderr,"CACHE1_CREATED\n");
    break;
  case CACHE1_OPENED:
    fprintf(stderr,"CACHE1_OPENED\n");
    break;
  case CACHE1_FAIL_OPEN:
    fprintf(stderr,"CACHE1_FAIL_OPEN\n");
  default:
    fprintf(stderr,"CACHE1_ FALLO ERROR\n");
    break;
  }
  mult=7;
  alist_new(&list, cache, sizeof(int));
  alist_iterator_new(list, &itr, 0);
  for (i = 0; i < max; i++) {
    *(int *)itr->next(itr) = i*mult;
    itr->get_current_index(itr,&array[i]);
    data = (int *)itr->current(itr);
    if (i*mult != *data) {
      fprintf(stderr,"ERROR i != data (%d != %d) \n",i*mult,*data);
      exit(-1);
    }
  }
  itr->close(itr);
  /*exit(0);*/
  fprintf(stderr,"FIN ENTRADA DE DATOS, AHORA RECORRIDO POR INDICE\n");
  head = list->ihead;
  alist_close(list);
  cache1_close(cache);
  cache1_open(&cache, NOMBRE,0640, 0, 1<<16, CACHE_SIZE);
  alist_open(&list,&head,cache);
  
  alist_iterator_new(list, &itr, 0);
 

  for (i = 0; i < max; i++) {
/*     alist_get_by_index(list, (void **)&data, &array[i]); */
    data = itr->jump(itr,&array[i]);
    if (i*mult != *data) {
      fprintf(stderr,"ERROR PRUEBA GET_BY_INDEX i:%d i*7 != data (%d != %d)\n",
	      i,i*mult,*data);
      exit(-1);
    }
/*     alist_put_element(list, &array[i]); */
  }
  
  itr->close(itr);

  alist_iterator_new(list, &itr,0);
  i = 0;
  data = itr->current(itr);
  fprintf(stderr,"CURRENT (FIRST ELEMENT): %d\n",*data);
  while (itr->has_next(itr)) {
    j = *((int *)itr->next(itr));
    if ((i*mult) != j) {
      fprintf(stderr,"Adelante Error iterando i=%d != j=%d\n",(i*mult),j);
      exit(-1);
    }
    i++;
  }
  if (j != (max-1)*mult) {
    fprintf(stderr,"Adelante Error faltan elementos max=%d != j=%d, i=%d\n",
	    ((max-1)*mult),j,i);
    exit(-1);
  }
  i--; /* Se comenzara de uno atrs al ltimo pues se recorre */
  if (i*mult != *(int *)itr->current(itr)) {
    fprintf(stderr,"Atras ULTIMO ELEMENTO %d\n",*(int *)itr->current(itr));
    exit(-2);
  }

  fprintf(stderr,"AHORA HACIA ATRAS\n");
  while (itr->has_prev(itr)) {
    j = *((int *)itr->prev(itr));
    i--;
    if ((i*mult) != j) {
      fprintf(stderr,"Atras Error iterando i=%d != j=%d\n",(i*mult),j);
      exit(-1);
    }
  }
  if (j != 0) {
    fprintf(stderr,"Atras Error faltan elementos i=%d != j=%d\n",i,j);
  }  
  itr->close(itr);

  alist_close(list);
  fprintf(stderr,"AHORA UNA NUEVA LISTA PARA PROBAR INSERCION POR ITERADOR\n");
  mult=9;
  alist_new(&list, cache, sizeof(int));
  alist_iterator_new(list, &itr, 0);
  for(i = 0; i < max; i++) {
    data=(int *)itr->next(itr);
    *data=i*mult;
    j = *((int *)itr->current(itr));
    if (i*mult != j) {
      fprintf(stderr,"000>>> INSERT Error i=%d != j=%d\n",i,j);
      exit(-1);
    }
  }
  fprintf(stderr,"PROBANDO LA INSERCION POR ITERADOR\n");
  i--;
  if (i*mult != *(int *)itr->current(itr)) {
    fprintf(stderr,"0000>>> PRUEBA ULTIMO ELEMENTO %d\n",
	    *(int *)itr->current(itr));
    exit(-2);
  }
  while (itr->has_prev(itr)) {
    j = *((int *)itr->prev(itr));
    i--;
    if ((i*mult) != j) {
      fprintf(stderr,"000>>> PRUEBA Error iterando i=%d != j=%d\n",(i*mult),j);
      exit(-1);
    }
  }
  itr->close(itr);
  alist_close(list);
  cache1_close(cache);
  fprintf(stderr,"=========================> FIN!!!\n");
  fclose(output);
  return 0;
}

