#include <trie_node.h>
#include <text_trie.h>
#include <alfabeto.h>
#include <stdlib.h>
#include <errno.h>
#include <cache1.h>
#include <idx_man.h>
#include <pthread.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <debug.h>

int get_random(int max)
{
  return (int)(drand48()*max);
}

#define CACHE_SIZE 1 /*1<<16 /* 1 << 16 */
#define CACHE_NOMBRE "prueba-cache"

#define MUESTRAS 1400
#define ALEATORIAS 100


int main(int argc, char **argv)
{
  FILE *output;
  int i,j,ret,page,elem;
  index_t ia, ib;
  cache1 *cache;
  trie_node *node, *pointer, *A,*B;
  srand48(time(NULL));
  /*output = fopen("output.log","w");*/
  output = stderr;
  unlink(CACHE_NOMBRE);
  switch(cache1_open(&cache, CACHE_NOMBRE, 0640, 0, CACHE_SIZE, 7)){
  case CACHE1_CREATED:
    fprintf(stderr,"CACHE1_CREATED\n");
    break;
  case CACHE1_OPENED:
    fprintf(stderr,"CACHE1_OPENED\n");
    break;
  case CACHE1_FAIL_OPEN:
    fprintf(stderr,"CACHE1_FAIL_OPEN\n");
  default:
    fprintf(stderr,"CACHE1_ FALLO ERROR\n");
    break;
  }
  for (i = 0; i < MUESTRAS; i++) {
    cache1_get_new_element(cache, (void **)&node, &ia); /*Open A*/
    ib.page = ia.page;
    ib.elem = 0;
    cache1_get_by_index(cache, (void **)&pointer, &ib); /*Open B*/
    fprintf(output,"NEW_ELEMENT page=%03d node-pointer=%p\n",ib.page, pointer);
    A=(char *)pointer + cache->header.chunk_size * ia.elem;
    if (A != node) {
      fprintf(stderr,"MAL CREANDO: pointer: %p, node: %p, A: %p\n",
	      pointer,node,A);
      exit(-1);
    } else {
      fprintf(stderr," OK CREANDO: elem_size: %d, elem: %d\n",
	      cache->header.chunk_size,ia.elem);
      fprintf(stderr," OK CREANDO: pointer: %p, node: %p, A: %p\n",
	      pointer,node,A);
      I_PRINT2(" OK CREANDO: ", ia);
    }
    cache1_put_element(cache, &ib); /*Close B*/
    node->final.page = ia.page*7;
    for (j = 0; j < LONGITUD_ALFABETO; j++) {
      ib.page = ia.page;
      ib.elem = ia.elem;
      ib.flags = 3;
      trie_node_set_symbol_by_index(node, j, &ib);
    }
    cache1_put_element(cache, &ia); /*Close A*/
  }
  fprintf(stderr,"CACHESIZE: %d\n",cache1_hash_size(cache));
  fprintf(stderr,"CACHELAST PAGE: %d\n",cache->header.last_position.page);
  fprintf(stderr,"CACHELAST ELEM: %d\n",cache->header.last_position.elem);
  /*exit(-2);*/
  page = ia.page;
  elem = cache->header.elements_per_page;

  fprintf(stderr,"GUARDANDO CACHE\n");
  cache1_close(cache);
  fprintf(stderr,"SALVADA\n");
  cache1_open(&cache, CACHE_NOMBRE, 0640, 0, CACHE_SIZE, 7);
  for (i = 0; i <= page; i++) {
    ia.page = i;
    ia.elem = 0;
    if (ia.page == 0) ia.elem++;
    cache1_get_by_index(cache, (void **)&node, &ia); /* Open AA*/
    fprintf(stderr,"FINAL: i=%d node-pointer=%p idx-value-final=%d, page=%d\n",
	    i,node, node->final.page,page);
    I_PRINT2("FINAL-NODE:",node->final);
    
    cache1_put_element(cache,&ia); /* Open AA*/
  }
  for (i = 0; i < ALEATORIAS; i++) {
    ia.page = get_random(page);
    ia.elem = 0;
    cache1_get_by_index(cache, (void **)&pointer, &ia);
    fprintf(output,"OPEN_ELEMENT page=%03d node-pointer=%p\n", ia.page, pointer);
    cache1_put_element(cache, &ia);
    ia.elem = get_random((cache->header.last_position.page == ia.page) ?
			 cache->header.last_position.elem :
			 cache->header.elements_per_page );
    if (ia.page == 0 && ia.elem == 0) ia.elem=1;
    cache1_get_by_index(cache, (void **)&node, &ia);
    A=(trie_node *)((char *)pointer + cache->header.chunk_size * ia.elem);
    if (A != node) {
      fprintf(stderr,"MAL: pointer: %p, node-pointer: %p, A-calc: %p\n",
	      pointer,node,A);
      I_PRINT2("MAL: ",ia);
      exit(-1);
    } else {
      fprintf(stderr," OK: elem_size: %d, elem: %d\n",
	      cache->header.chunk_size,ia.elem);
      fprintf(stderr," OK: pointer: %p, node: %p, A: %p\n",pointer,node,A);
    }
    fprintf(stderr,"\n\nREPORTE i=%d, page: %d, elem %d\n\n",
	    i, ia.page, ia.elem);
    fprintf(stderr,"==========> node->final.page:%d\n",node->final.page);
    for (j = 0; j < LONGITUD_ALFABETO; j++) {
      ret = 0;
      ib = *trie_node_get_symbol_by_index(node, j);
      if (ib.page != ia.page) {
	ret = 1;
	fprintf(stderr," page: ib:%d != ia:%d, ", ib.page, ia.page);
      }
      if (ib.elem != ia.elem) {
	ret = 1;
	fprintf(stderr," elem: ib:%d != ia:%d, ", ib.elem, ia.elem);
      }
      if (ib.flags != 3) {
	ret = 1;
	fprintf(stderr," flags: ib:%d != 3 ", ib.flags);
      }
      if (ret) {
	fprintf(stderr,"\nFALLO\n");
	exit(-1);
      }
    }
    cache1_put_element(cache, &ia);
  }
  cache1_close(cache);
  fprintf(stderr,"=========================> FIN!!!\n");
  fclose(output);
  return 0;
}

