#include <trie_node.h>
#include <text_trie.h>
#include <alfabeto.h>
#include <stdlib.h>
#include <errno.h>
#include <cache1.h>
#include <idx_man.h>
#include <pthread.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

int get_random(int max)
{
  return (int)(drand48()*max);
}

void debug(cache1 *cache, char *id)
{
  trie_node *node;
  fprintf(stderr,"\n\n %s \n========> debug\n",id);
  fprintf(stderr,"POSICION INICIAL: %d\n",lseek(cache->fd, 0, SEEK_CUR));
  lseek(cache->fd, 4096, SEEK_SET);
  fprintf(stderr,"POSICION LECTURA: %d\n",lseek(cache->fd, 0, SEEK_CUR));
  node = malloc(SIZEOF_TRIENODE(LONGITUD_ALFABETO));
  read(cache->fd, node, SIZEOF_TRIENODE(LONGITUD_ALFABETO));
  trie_node_inspect(node);
  fprintf(stderr,"POSICION FINAL: %d\n",lseek(cache->fd, 0, SEEK_CUR));
  if (node->alfabeto[0].page != 11) {
    fprintf(stderr,"muerte!\n");
    exit(-1);
  }
  free(node);
}

#define NOMBRE "prueba-cache2"
#define max 1500
int main(int argc, char **argv)
{
  FILE *output;
  int i,j,k,ret,page,elem;
  index_t ia, ib;
  cache1 *cache;
  trie_node *node, *pointer, *A,*B;
  srand48(time(NULL));
  output = fopen("output.log","w");
  unlink(NOMBRE);
  switch(cache1_open(&cache, NOMBRE, 0640, 0, 1, 7)) {
  case CACHE1_CREATED:
    fprintf(stderr,"CACHE1_CREATED %d\n", SIZEOF_TRIENODE(LONGITUD_ALFABETO));
    break;
  case CACHE1_OPENED:
    fprintf(stderr,"CACHE1_OPENED\n");
    break;
  case CACHE1_FAIL_OPEN:
    fprintf(stderr,"CACHE1_FAIL_OPEN\n");
  default:
    fprintf(stderr,"CACHE1_ FALLO ERROR\n");
    break;
  }
  for (i = 0; i < max; i++) {
    fprintf(stderr,"========    {{{{{{{ PIDIENDO %d\n",i);
    cache1_get_new_element(cache, (void **)&node, &ia); /*Open A*/
    fprintf(stderr,"========            RECIBIDO }}}}}}} \n");
    ib.page = ia.page;
    ib.elem = 0;
    cache1_get_by_index(cache, (void **)&pointer, &ib); /*Open B*/
    fprintf(output,"NEW_ELEMENT page=%03d %p\n", ib.page, pointer);
    A=(trie_node *)((char *)pointer + cache->header.chunk_size * ia.elem);
    if (A != node) {
      fprintf(stderr,"MAL CREANDO: pointer: %p, node: %p, A: %p\n",
	      pointer,node,A);
      exit(-1);
    } else {
      fprintf(stderr," OK CREANDO: elem_size: %d, elem: %d\n",
	      cache->header.chunk_size,ia.elem);
      fprintf(stderr," OK CREANDO: pointer: %p, node: %p, A:%p, ",
	      pointer,node,A);
      fprintf(stderr," DIFF: %d\n", (char *)node - (char *)pointer);
    }
    
    cache1_put_element(cache, &ib); /*Close B*/
    fprintf(stderr,"--------> {{{{{{{ LLENANDO\n");
    node->final.page = ia.page*11;
    for (j = 0; j < LONGITUD_ALFABETO; j++) {
      ib.page = ia.page*11;
      ib.elem = j % 8;
      ib.flags = ia.elem % 4;
      trie_node_set_symbol_by_index(node, j, &ib);
    }
    fprintf(stderr,"----------         }}}}}}}\n");
    cache1_put_element(cache, &ia); /*Close A*/
    cache1_get_by_index(cache, (void **) &node, &ia);
    I_PRINT2("\n\n::::::::FINAL::::> ",node->final);
    cache1_put_element(cache, &ia);
  }

  fprintf(stderr,"CACHESIZE: %d\n",cache1_hash_size(cache));
  fprintf(stderr,"CACHELAST PAGE: %d\n",cache->header.last_position.page);
  fprintf(stderr,"CACHELAST ELEM: %d\n",cache->header.last_position.elem);
  fprintf(stderr,"PAGES!!: %d\n",cache1_hash_size(cache));
  fprintf(stderr,"SIZEOFDOCID: %d\n",sizeof(id_doc_t));
  page = ia.page;
  /*for (i = 0; i < 200;i++) fprintf(stderr,"random %d\n",get_random(100)); */
  elem = ia.elem;
  cache1_close(cache);
  /*chmod(NOMBRE, 0400);*/
  cache1_open(&cache, NOMBRE, 0400, 1, 1, 7);
  for (i = 0; i <= page; i++) {
    ia.page = i;
    ia.elem = 0;
    if (ia.page == 0) ia.elem++;
    fprintf(stderr,"((((( LLENANDO %d\n",cache1_hash_size(cache));
    cache1_get_by_index(cache, (void **)&node, &ia); /* Open AA*/
    fprintf(stderr,"~~~~~~~~~> node: %p, cache: %p, sizeheader%d\n",
	    node,cache,sizeof(cache1_head));
    fprintf(stderr,"      LLENANDO )))))\n");
    I_PRINT2("NODE: ", ia);
    fprintf(stderr,"FINAL page=%d pointer=%p final=%d\n",i,node,
	    node->final.page);
    if (ia.page*11 != node->final.page) {
      fprintf(stderr,"FALLO page(%d) != final(%d)\n",
	      ia.page*11,node->final.page);
      I_PRINT(ia);
      fprintf(stderr,"==> %d\n",sizeof(cache1_page));
      /*exit(-2);*/
    }
    cache1_put_element(cache,&ia); /* Close AA*/
  }

  fprintf(stderr,"PRUEBAS DE PERSISTENCIA DE INFORMACION\n");
  for (i = 0; i <= page; i++) {
    ia.page = i;
    for (k = 0; k < cache->header.elements_per_page; k++) {
      if (k == 0 && i == 0) k++;
      fprintf(stderr,"LLEGO AL FINAL i:%d k:%d\n",i,k);
      fprintf(stderr,"LLEGO AL FINAL page:%d elem:%d\n",page,elem);
      if (i == page && k == elem) {
	fprintf(stderr,"LLEGO AL FINAL\n");
	break;
      }
      ia.elem = k;
      fprintf(stderr,"(((((((GET_BY_INDEX\n");
      cache1_get_by_index(cache, (void **)&node, &ia);
      fprintf(stderr,"       )))))))\n");
      for (j = 0; j < LONGITUD_ALFABETO; j++) {
	ret = 0;
	ib = *trie_node_get_symbol_by_index(node, j);
	if (ib.page != ia.page*11) {
	  ret = 1;
	  fprintf(stderr," page: ib:%d != ia:%d, ", ib.page, ia.page*11);
	}
	if (ib.elem != j % 8) {
	  ret = 1;
	  fprintf(stderr," elem: ib:%d != ia:%d, ", ib.elem, ia.elem);
	}
	if (ib.flags != (ia.elem % 4)) {
	  ret = 1;
	  fprintf(stderr," flags: ib:%d != ia=%d ", ib.flags,ia.elem % 4);
	}
	if (ret) {	 
	  I_PRINT2("\nFALLO EN: ",ia);
	  trie_node_inspect(node);
	  exit(-1);
	}
      }
      cache1_put_element(cache, &ia);
    }
  }

  cache1_close(cache);
  fprintf(stderr,"=========================> FIN!!!\n");
  fclose(output);
  return 0;
}

