#include <trie_node.h>
#include <text_trie.h>
#include <alfabeto.h>
#include <stdlib.h>
#include <errno.h>
#include <cache1.h>
#include <idx_man.h>
#include <pthread.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <math.h>
#include <stdio.h>
#include <signal.h>
#include <debug.h>

#define CACHE_SIZE 1<<16 /* 1 << 16 */
#define CACHE_NOMBRE "prueba-cache"

#define MUESTRAS 14
#define ALEATORIAS 100

cache1 *cache;
FILE *output;
#define NUM_THREADS 8
pthread_t threads[NUM_THREADS];


void signal_handler(int signal)
{
  fprintf(stderr,"SIGNAL %d on thread %d\n",signal,pthread_self());
  debug_backtrace();
}

void register_signals()
{
  int i;
  struct sigaction act;
  act.sa_handler = signal_handler;
  act.sa_flags = SA_ONSTACK;
  sigaction(11, &act, NULL);
  for (i = 0; /*SIGRTMIN;*/ i <= SIGRTMAX; i++) {
    sigaction(i, &act, NULL);
  }
  fprintf(stderr, "SIGRTMIN: %d, MAX: %d\n",SIGRTMIN,SIGRTMAX);
}

void* thread(void *args)
{
  int i,j,k,ret,page,elem,max;
  index_t ia, ib;
  trie_node *node, *pointer;
  register_signals();
  max = MUESTRAS;
  for (i = 0; i < max; i++) {
    fprintf(stderr,"========    {{{{{{{ PIDIENDO %d\n",i);
    cache1_get_new_element(cache, (void **)&node, &ia); /*Open A*/
    fprintf(stderr,"========            RECIBIDO }}}}}}} \n");
    ib.page = ia.page;
    ib.elem = 0;
    fprintf(stderr,"--------> {{{{{{{ LLENANDO\n");
    node->final.page = ia.page*11;
    for (j = 0; j < LONGITUD_ALFABETO; j++) {
      ib.page = ia.page*11;
      ib.elem = j;
      ib.flags = ia.elem % 8;
      trie_node_set_symbol_by_index(node, j, &ib);
    }
    fprintf(stderr,"----------         }}}}}}}\n");
    cache1_put_element(cache, &ia); /*Close A*/
    cache1_get_by_index(cache, (void **) &node, &ia);
    I_PRINT2("\n\n::::::::FINAL::::> ",node->final);
    cache1_put_element(cache, &ia);
  }

  fprintf(stderr,"CACHESIZE: %d\n",cache1_hash_size(cache));
  fprintf(stderr,"CACHELAST PAGE: %d\n",cache->header.last_position.page);
  fprintf(stderr,"CACHELAST ELEM: %d\n",cache->header.last_position.elem);
  fprintf(stderr,"PAGES!!: %d\n",cache1_hash_size(cache));
  fprintf(stderr,"SIZEOFDOCID: %d\n",sizeof(id_doc_t));
  page = ia.page;

  elem = ia.elem;

  for (i = 0; i <= page; i++) {
    ia.page = i;
    ia.elem = 0;
    if (ia.page == 0) ia.elem++;
    fprintf(stderr,"((((( LLENANDO %d\n",cache1_hash_size(cache));
    cache1_get_by_index(cache, (void **)&node, &ia); /* Open AA*/
    fprintf(stderr,"~~~~~~~~~> node: %p, cache: %p, sizeheader%d\n",
	    node,cache,sizeof(cache1_head));
    fprintf(stderr,"      LLENANDO )))))\n");
    I_PRINT2("NODE: ", ia);
    fprintf(stderr,"FINAL page=%d pointer=%p final=%d\n",i,node,
	    node->final.page);
    if (ia.page*11 != node->final.page) {
      fprintf(stderr,"FALLO page(%d) != final(%d)\n",
	      ia.page*11,node->final.page);
      I_PRINT(ia);
      fprintf(stderr,"==> %d\n",sizeof(cache1_page));
      /*exit(-2);*/
    }
    cache1_put_element(cache,&ia); /* Close AA*/
  }

  fprintf(stderr,"PRUEBAS DE PERSISTENCIA DE INFORMACION\n");
  for (i = 0; i <= page; i++) {
    ia.page = i;
    for (k = 0; k < cache->header.elements_per_page; k++) {
      if (k == 0 && i == 0) k++;
      fprintf(stderr,"LLEGO AL FINAL i:%d k:%d\n",i,k);
      fprintf(stderr,"LLEGO AL FINAL page:%d elem:%d\n",page,elem);
      if (i == page && k == elem) {
	fprintf(stderr,"LLEGO AL FINAL\n");
	break;
      }
      ia.elem = k;
      fprintf(stderr,"(((((((GET_BY_INDEX\n");
      cache1_get_by_index(cache, (void **)&node, &ia);
      fprintf(stderr,"       )))))))\n");
      for (j = 0; j < LONGITUD_ALFABETO; j++) {
	ret = 0;
	ib = *trie_node_get_symbol_by_index(node, j);
	if (ib.page != ia.page*11) {
	  ret = 1;
	  fprintf(stderr," page: ib:%d != ia:%d, ", ib.page, ia.page*11);
	}
	if (ib.elem != j) {
	  ret = 1;
	  fprintf(stderr," elem: ib:%d != ia:%d, ", ib.elem, ia.elem);
	}
	if (ib.flags != ia.elem % 8) {
	  ret = 1;
	  fprintf(stderr," flags: ib:%d != ia=%d ", ib.flags,ia.elem%8);
	}
	if (ret) {	 
	  I_PRINT2("\nFALLO EN: ",ia);
	  trie_node_inspect(node);
	  exit(-1);
	}
      }
      cache1_put_element(cache, &ia);
    }
  }
  return NULL;
}

int main(int argc, char **argv)
{
  int i,ret;
  output = stderr;
  register_signals();
  unlink(CACHE_NOMBRE);
  switch(cache1_open(&cache, CACHE_NOMBRE,
		     0640, 0, CACHE_SIZE, SIZEOF_TRIENODE(LONGITUD_ALFABETO))) {
  case CACHE1_CREATED:
    fprintf(stderr,"CACHE1_CREATED\n");
    break;
  case CACHE1_OPENED:
    fprintf(stderr,"CACHE1_OPENED\n");
    break;
  case CACHE1_FAIL_OPEN:
    fprintf(stderr,"CACHE1_FAIL_OPEN\n");
  default:
    fprintf(stderr,"CACHE1_ FALLO ERROR\n");
    break;
  }
  for (i = 0; i < NUM_THREADS; i++) {
    ret = pthread_create(&threads[i], NULL, thread, NULL);
    if (ret != 0) {
      perror("main:pthread_create");
      fprintf(stderr, "Error posible EAGAIN: %d, ret: %d\n", EAGAIN, ret);
      exit(1);
    }
  }
  for (i = 0; i < NUM_THREADS; i++) {
    pthread_join(threads[i], NULL);
    if (ret != 0) {
      perror("main:pthread_join");
    }
  }
  cache1_close(cache);
  fprintf(stderr,"=========================> FIN!!!\n");
  fclose(output);
  return 0;
}

