#include <alfabeto.h>
#include <stdlib.h>
#include <cache1.h>
#include <text_trie.h>
#include <idx_man.h>
#include <string.h>
#include <stdio.h>
#include <id_wrd_t.h>
#include <alfabeto.h>
#include <document_env.h>
#include <query.h>
#include <config_main.h>
#include <skip_list.h>
#include <id_doc_t.h>
#include <vector_model.h>
#include <boolean_model.h>

#define MAIN_MAX_LENGTH_NAME 512
char main_name[MAIN_MAX_LENGTH_NAME];
void main_print(query_result *qr, document_env *env)
{
  skip_list_iterator *qritr;
  id_doc_t *doc;
  float sim;
  int i = 0;
  skip_list_iterator_new(qr->docs, &qritr);
  while (skip_list_iterator_has_next(qritr) && i++ < qr->psize) {
    qr->get_info(qr, skip_list_iterator_next(qritr), &doc, &sim);
    env->get_name(env, doc, main_name, MAIN_MAX_LENGTH_NAME);
    fprintf(stderr, "Doc %i, sim(%f): %s\n", qritr->position, sim, main_name);
  }
  skip_list_iterator_close(qritr);
}

int main(int argc,char **argv)
{
  idx_man *idm;
  cache1 *idx_info, *dat_info;
  document_env *env;
  query *q;  query_result *qr;
  int i, is_and, skipres, maxres;

  if (argc < 4) {
    fprintf(stderr,"%s {y|o|vector} skip-results max-results query-words+\n",
	    argv[0]);
    exit(1);
  }

  cache1_open(&idx_info, CFG_IDX_NAME, 0400, 0,
	      CFG_QUERY_CACHE_IDX_SIZE, CFG_CACHE_IDX_DIVS);
  cache1_open(&dat_info, CFG_DAT_NAME, 0400, 0,
	      CFG_QUERY_CACHE_DAT_SIZE, CFG_CACHE_DAT_DIVS);
  /*  document_env_open_trie(&env, idx_info, CFG_QUERY_DOC_ENV_SIZE, 0440);*/
  document_env_open_always_increment(&env, idx_info, 0440,CFG_DOCENV_BASENAME);
  text_trie_open_master(&idm, CFG_IDM_NAME, 0400,
			CFG_QUERY_TRIE_SIZE, LONGITUD_ALFABETO,-1);
  text_trie_set_caches(idm, idx_info, dat_info);
  is_and = (strcmp("y",argv[1]) == 0);
  skipres = atoi(argv[2]);
  maxres = atoi(argv[3]);
  query_new(&q, env, idm, argv+4, argc-4);
  if (query_init(q, is_and)) {
    fprintf(stderr, "argumento '%s'\n", argv[1]);
    if (is_and) {
      qr = boolean_model_and(q, skipres, maxres);
    } else if (strcmp("o", argv[1]) == 0) { 
      qr = boolean_model_or (q, skipres, maxres);
    } else {
      fprintf(stderr, "Utilizando modelo vectorial\n");
      qr = vector_model(q, skipres, maxres);
    }
    fprintf(stderr, "Coleccin de %lld documentos\n", *env->num_docs);
    fprintf(stderr, "Documentos encontrados para\n");
    
    for (i = 0; i < q->argc; i++) {
      fprintf(stderr, "%s -> %d\n", q->argv[i], q->gdata[i].number_docs);
    }
    fprintf(stderr,"Resultados mostrando %d\n", qr->docs->num_nodes);
    main_print(qr, env);
    query_result_free(qr);
  }
  query_close(q);
  env->close(env);
  idm->close(idm);
  return 0;
}
