#!/bin/sh
cat <<'MAKEFILE' > Makefile
CC=gcc
# if CC is g++ then -D__cplusplus
CFLAGS =-pg -I. -I/usr/local/include -I/usr/local/include/db42 -W -Wall -g #-mcpu=pentium4 -msse2 -msse3 -O9
#CFLAGS =-I. -I/usr/local/include -I/usr/local/include/db42 -W -Wall -march=pentium4 -msse2 -msse3 -O9
CPPFLAGS=-I. -D_REENTRANT
LDFLAG0=-L/usr/local/lib -rdynamic
#LDFLAG1=/usr/lib/libefence.a
LDFLAGS=$(LDFLAG0) $(LDFLAG1)
LIBS = -lpthread -lm -lz -ldb
#LIBS = -lpthread -lobjc -lm -lz -I/usr/local/BerkeleyDB.4.2/lib/ -ldb -lmhash
OFILES = alfabeto.o cache1.o skip_list.o alist.o idx_man.o document_env.o document.o text_trie.o trie_node.o super_malloc.o list_node.o debug.o id_wrd_t.o query.o id_doc_t.o vector_model.o boolean_model.o misc.o memindex.o

OFILES_CREA=main_crea.o $(OFILES)
OFILES_CONS=main_cons.o $(OFILES) 

.SUFFIXES: .o .m

.m.o:
	$(CCOBJ) $(CPPFLAGS) $(CFLAGS) -c $<


#all: main_cons main_crea pruebas
all: main_cons main_crea



btree: btree.o $(OFILES)
	$(CC) $(CFLAGS) $(OFILES) -o main_btree btree.o $(LDFLAGS) $(LIBS)

main_crea: $(OFILES_CREA)
	$(CC) $(CFLAGS) $(OFILES_CREA) -o main_crea $(LDFLAGS) $(LIBS)

main_cons: $(OFILES_CONS)
	$(CC) $(CFLAGS) $(OFILES_CONS) -o main_cons $(LDFLAGS) $(LIBS)

pruebas: main_alist main_alist2 main_cache main_cache2 main_list main_cache_thread

main_text_trie_3: $(OFILES) main_text_trie_3.o
	$(CC) $(CFLAGS) $(OFILES) main_text_trie_3.o -o main_text_trie_3 $(LDFLAGS) $(LIBS)

main_cache2: $(OFILES) main_cache2.o
	$(CC) $(CFLAGS) $(OFILES) main_cache2.o -o main_cache2 $(LDFLAGS) $(LIBS)

main_cache_thread: $(OFILES) main_cache_thread.o
	$(CC) $(CFLAGS) $(OFILES) main_cache_thread.o -o main_cache_thread $(LDFLAGS) $(LIBS)

main_cache: $(OFILES) main_cache.o
	$(CC) $(CFLAGS) $(OFILES) main_cache.o -o main_cache $(LDFLAGS) $(LIBS)

main_list: $(OFILES) main_list.o
	$(CC) $(CFLAGS) $(OFILES) main_list.o -o main_list $(LDFLAGS) $(LIBS)

main_alist2: $(OFILES) main_alist2.o
	$(CC) $(CFLAGS) $(OFILES) main_alist2.o -o main_alist2 $(LDFLAGS) $(LIBS)

main_alist: $(OFILES) main_alist.o
	$(CC) $(CFLAGS) $(OFILES) main_alist.o -o main_alist $(LDFLAGS) $(LIBS)

clean:
	rm -f $(OFILES)  consulta crea main_{cache{,2,_thread},alist{,2},cons,crea,list}{,.o}
	rm -f alfabeto prueba-cache{,2} a{0,1}-cache log 
libreria:$(OFILES)
	$(CC) $(CFLAGS) $(LIBS) $(OFILES) -shared -fPIC -o libindex.so

alfabeto.h: alfabeto
	[ -f alfabeto.h ] && cp -f alfabeto.h alfabeto.h.bak
	./alfabeto 

alfabeto: crea_alfabeto.c
	$(CC) $(CFLAGS) crea_alfabeto.c -o alfabeto
# correr
# gccmakedep -I. *.c *.m
# para actualizar dependencias, debajo de DO NOT DELETE se pone todo
# DO NOT DELETE
MAKEFILE
gcc -M -I. -I/usr/local/include -I/usr/local/include/db42 *.c >> Makefile
