#include <super_malloc.h>
#include <string.h>
#include <document.h>
#include <memindex.h>

/* To check the occurrence list*/
int
memiword_cmp(void *a, void *b)
{
  return ((mementry *)b)->freq - ((mementry *)a)->freq;
}

/* void* memiword_alloc(void *a) */
/* { */
/*   return a; */
/* } */

/* void* memiword_dup(void *a, void *b) */
/* { */
/* } */

/*************** Para crear la lista desde un documento */
void*
memindex_alloc(memread *readed)
{
  memiword *w = struct_malloc(memiword);
  w->num_docs = 1;
  w->wrd = strndup(readed->wrd,64);
  w->occurrences = skip_list_new(0.5, 512, memiword_cmp, NULL, NULL);
  mementry *e = struct_malloc(mementry);
  e->doc = *readed->doc;
  e->freq = 1;
  skip_list_insert(w->occurrences, e);
  return w;
}

int
memindex_cmp(memread *newval, memiword *oldlist)
{
  return strcmp(((memread *)newval)->wrd, ((memiword *)oldlist)->wrd);
}


/* Cuando ya existe una palabra en el documento y se vuelve a encontrar */
void*
memindex_dup(memread *newval, memiword *inlist)
{
  ((mementry *)skip_node_next(inlist->occurrences->head)->data)->freq++;
  return inlist;
}

skip_list*
memindex_new()
{
  skip_list *list = skip_list_new(0.5, 512, memindex_cmp, memindex_dup,
				  memindex_alloc);
  return list;
}

void memindex_free(memiword *iword)
{
  free((iword)->wrd);
  skip_list_free(iword->occurrences, free);
  free(iword);
}

void memindex_close(skip_list *wlist)
{
  skip_list_free(wlist, memindex_free);
}

skip_list * memindex_update(skip_list *a, skip_list *b)
{
  memiword *wa, *wb;
  skip_list_iterator *ib;
  skip_list *oa, *ob, *c;

  if (a->num_nodes < b->num_nodes) {
    c = a;
    a = b;
    b = a;
  }
  skip_list_iterator_new(b, &ib);
  while (skip_list_iterator_has_next(ib)) {
    wb = skip_list_iterator_next(ib);
    wa = skip_list_search(a, wb->wrd);
    if (wa == NULL) {
      skip_list_insert(a, wa);
      continue;
    }
    oa = wa->occurrences;
    ob = wb->occurrences;
    if (oa->num_nodes < ob->num_nodes) {
      c = oa;
      oa = ob;
      ob = c;
    }
    //while (skip_list) 
  }
}

skip_list* memindex_read(document *doc, id_wrd_t *wrd, id_doc_t *idoc)
{
  memread mr;
  mr.doc = idoc;
  skip_list *wlist = skip_list_new(0.5, 4096/6, memindex_cmp,
				   memindex_dup, memindex_alloc);
  while (document_read_word(doc, wrd, 63)) {
    if (wrd->len == 0) continue;
    mr.wrd = wrd->key;
    skip_list_insert(wlist, &mr);
  }
  return wlist;
}

void memindex_dump(skip_list *index, char *basename)
{
  skip_list_iterator *witer, *eiter;
  mementry *entry;
  memiword *iword;
  FILE *f = fopen(basename, "w+");
  if (f == NULL) {
    perror("document_save_vectorized: ");
    fprintf(stderr,"'%s'",basename);
    return;
  }
  skip_list_iterator_new(index, &witer);
  while (skip_list_iterator_has_next(witer)) {
    iword = (memiword *)skip_list_iterator_next(witer);
    fprintf(f, "%s, %d: ", iword->wrd, iword->num_docs);
    skip_list_iterator_new(iword->occurrences, &eiter);
    while (skip_list_iterator_has_next(eiter)) {
      entry = (mementry *)skip_list_iterator_next(eiter);
      fprintf(f, "(%d:%d,%d) ",entry->doc.major,entry->doc.minor,
	      entry->freq);
    }
    fprintf(f, "\n");
    skip_list_iterator_close(eiter);
  }
  skip_list_iterator_close(witer);
  fclose(f);
}


/* void memindex_loads() */
/* { */
/* } */

/* void memindex_merge() */
/* { */
/* } */
