#include <string.h>
#include <misc.h>
#include <super_malloc.h>

char* xstrcat(const char *base, const char *suffix)
{
  int lbase, lsuffix;
  char *name;
  lbase = strlen(base);
  lsuffix = strlen(suffix) + 1;
  name = (char *)super_malloc(lbase+lsuffix);
  memcpy(name, base, lbase);
  memcpy(name+lbase, suffix, lsuffix);
  return name;
}

int xdbopen(DB *db, const char *name, int flags, int perm)
{
#if (DB_VERSION_MAJOR < 4 || DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR < 2)
  return db->open(db, name, name, DB_BTREE, DB_THREAD|flags, perm);
#else
  return db->open(db, NULL, name, name, DB_BTREE, DB_THREAD|flags, perm);
#endif
}
