cdef extern from "skip_list.h":
    ctypedef struct skip_list:
        char max_level
        int num_nodes
        float prob
        int (*cmp)(void *a, void *b)
        void* (*dup)(void *a, void *b)
        alloc* (*dup)(void *a, void *b)

    void* skip_list_search(struct skip_list * list, void *value)
    void skip_list_free(skip_list *l, void (*f_free)(void *d))
    skip_list* skip_list_new(float prob, int max_num,
                             int (*cmp)(void *a, void *b),
                             void* (*dup)(void *a, void *b)
                             alloc* (*dup)(void *a, void *b))
    
