#include <cache1.h>
#include <trie_node.h>
#include <alfabeto.h>
#include <stdlib.h>

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <debug.h>

void trie_node_init_new(trie_node *n, int size)
{
  int i;
  TNODE_SET_NIL_FINAL(n);
  for (i = 0; i < size; i++) {
    TNODE_SET_NIL(n, i);
  }
}

trie_node * trie_node_new(int size)
{
  trie_node *n;
  n = (trie_node *) calloc(size+1, sizeof(index_t));
  if (n == NULL) {
    perror("trie_node_new");
    exit(1);
  }
  trie_node_init_new(n, size);
  return n;
}

void trie_node_free(trie_node *node)
{
  free(node);
}

trie_node * trie_node_init(trie_node *n, const trie_node *init_node, int size)
{
  memcpy(n, init_node, SIZEOF_TRIENODE(size));
  return n;
}

/* se cambiaron por macros 
index_t* trie_node_get_symbol_by_index(trie_node *n, int index) 
{
  return &n->alfabeto[index];
}

void trie_node_set_symbol_by_index(trie_node *n, int index, index_t* value)
{
  n->alfabeto[index] = *value;
}

int trie_node_get_kind_by_index(trie_node *n, int index)
{
  return TNODE_GET_FLAG(trie_node_get_symbol_by_index(n,index));
}

*/
int trie_node_set_index(trie_node *n, int index, index_t *value)
{
  TNODE_SET_FLAG(value,TNODE_IDX_VALUE);
  trie_node_set_symbol_by_index(n,index,value);
  return 0;
}

/* Pone el la posicin correspondiente a |char_pos| como fin de palabra
   en |n|, se modifica index */
void trie_node_set_word_end(trie_node *n, int char_pos, index_t *index)
{
  TNODE_SET_FLAG(index,TNODE_END_VALUE);
  trie_node_set_symbol_by_index(n,char_pos,index);
}
/* Son macros ahora
index_t *trie_node_get_final(trie_node *n)
{
  return &n->final;
}

void trie_node_set_at_final_field(trie_node *n, const index_t *index)
{
  n->final = *index;
}
*/
void trie_node_inspect(trie_node *n)
{
  int i;
  fprintf(stderr,"******************************\nMemoria: %p\n", n);
  debug_index(trie_node_get_final(n), "Campo Final: ");
  for (i = 0; i < LONGITUD_ALFABETO; i++) {
    fprintf(stderr,"int:%d, char:%c => ", i, alfa_get_char_by_index(i));
    debug_index(trie_node_get_symbol_by_index(n,i), "");
  }
  fprintf(stderr,"******************************\n");
}
