#include <query.h>
#include <list_node.h>
#include <skip_list.h>
#include <id_doc_t.h>
#include <vector_model.h>
#include <math.h>
#include <stdio.h>

int vector_model_cmp_sim(void *in_skip_list, void *new_data)
{
  float res = 
    ((vector_model_item *)new_data)->sim
    -
    ((vector_model_item *)in_skip_list)->sim
    ;

  /*fprintf(stderr, "in_skip_list: %f, new_data: %f, res: %f\n",
	  ((vector_model_item *)in_skip_list)->sim,
	  ((vector_model_item *)new_data)->sim, res); */
  if (res == 0) return 0;
  return (res > 0) ? 1 : -1;
}

void vector_model_get_info(query_result *res, void *data, id_doc_t **doc,
				float *sim)
{
  vector_model_item * item = (vector_model_item *)data;
  *doc =&item->doc;
  *sim = item->sim;
}

query_result* vector_model(query *q, int begin, int count)
{
  int j, any, is_set;
  iterator *itr;
  id_doc_t dmin;
  vector_model_item *item;
  query_result *res;
  /*query_reset(q);*/
  query_result_new(&res, count, vector_model_get_info,
		   vector_model_cmp_sim, NULL);
  idx_data *data;
  register float tmpreg, Qden, dden, num,
    *qTFIDF = array_malloc(float, q->argc),
    *dTFIDF = array_malloc(float, q->argc),
    *rTFIDF  = array_malloc(float, q->argc);
  double max_freq;
  Qden = 0;
  for (j = 0; j < q->argc; j++) {
    /* term_freq = 1.0, max_freq = 1.0, queda IDF */
    /* fprintf(stderr,"Documentos con termino:
       %lld, collection_size: %lld\n",
       q->gdata[j].number_docs, q->collection_size); */
    if (q->gdata[j].number_docs == 0) {
      tmpreg = 1.0f;
    } else {
      tmpreg = log((q->collection_size)*1.0f/q->gdata[j].number_docs);
    }
    qTFIDF[j] = tmpreg;
    Qden += tmpreg * tmpreg;
    /*fprintf(stderr, "\n\n******** j=%d, \nskip_listnnodes: %d\n",j,
      res->docs->num_nodes);
      fprintf(stderr, "query gdata: (docs=%d, gfreq=%d)\n",
      q->gdata[j].number_docs, q->gdata[j].global_freq);
      fprintf(stderr, "collection size: %d\n", q->collection_size);
      fprintf (stderr, "query TFIDF[%s]: %f\n",q->argv[j],qTFIDF[j]);
      fprintf(stderr, "pointer: q: %p\n", q); */
  }
  Qden = sqrt(Qden);
  do {
    any = 0;
    is_set = 0;
    dden = num = 0; /*sumas denominador query, den-doc, numerador*/
    /* buscando el vector del documento  en for index:j */
    /*fprintf(stderr,"\n\n==============================\n");*/
    for (j = 0; j < q->argc; j++) {
      itr = q->itrs[j];
      if (itr == NULL) continue;
      if (is_set == 0) {
	is_set = 1;
	dmin = query_get_min(q);
	max_freq = q->env->get_maxfreq(q->env, &dmin);
      }
      /* Existe al menos uno, el que lo creo */
      data = (idx_data *)itr->current(itr);
      if (itr->has_next(itr) == 0) q->itrs[j] = NULL;
      if (idx_man_doc_find_cmp(data, &dmin)) { /*no igual*/
	dTFIDF[j] = 0;
	continue;
      }
      any = 1;
      if (q->itrs[j]) itr->next(itr); /* adelantando apuntador de documento */
      dTFIDF[j] = data->freq/max_freq * qTFIDF[j]; /*ya que qTFIDF==IDF*/
      /*fprintf (stderr, "[%s] MAXFREQ: %f, freq: %d, dTFIDF: %f\n",q->argv[j],
	       max_freq,data->freq, dTFIDF[j]);
      fprintf (stderr, "[%s] dTFIDF: %f, qTFIDF: %f\n",q->argv[j],
      dTFIDF[j], qTFIDF[j]);*/
      num += (dTFIDF[j] * qTFIDF[j]);
      dden += (dTFIDF[j] * dTFIDF[j]);
    }
    if (any == 0) break;
    item = struct_malloc(vector_model_item);
    item->doc = dmin;
    /* Exists sim == 0 :) */
    dden += 0.25 * max_freq;
    item->sim = (Qden  == 0 || dden == 0) ? 0 : num / (Qden * sqrt(dden));
    /*fprintf(stderr, "qDEN: %f, dDEN: %f, num: %f, SIMILARITY: %f, SIM2: %lf\n", Qden, dden, num, item->sim, (Qden * sqrt(dden)));*/
    res->push(res, item);
  } while (any);
  for (j = 0; j < begin; j++) {
    res->pop(res);
  }
  free(dTFIDF);
  free(qTFIDF);
  return res;
}
