#!/usr/bin/python
#coding: iso-8859-1;

############################################################################
#                                                                          #
#    This file 'SPyDI.py'                                                  #
#    is part of 'SPyDI: Simple Python Distributed Indexing'                #
#    Copyright (C) 2006      by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import os, sys
import cgi
import SPyRO as spyro
#import Monarca
import monarca
import monarca.server
import monarca.session as session

from monarca import template
from Sendmail import Sendmail
import socket
import warn as debug
from Harvest import Harvest
import threadutils
from threadutils import ServerInThread
import distributor
import router
#import spydihub, spydiidx
import spydihub, spydex
from Repository import Repository
import warn
import Crawler
import sre

import os, sys

class ConfigTemplate:
    def __init__(self, root = None, cwd = None):
        #self.cwd = os.path.dirname(os.path.abspath(__file__))
        #self.root = os.path.dirname(os.path.abspath(__file__)) + "/../.."
        if not cwd: cwd = os.getcwd()
        self.cwd = cwd
	if not root: root = cwd
        self.root = root
        self.python_path = [cwd, root] # the python's module path
        #self.root = os.path.abspath(os.path.curdir)
        #self.root = "/home/sadit/information_retrieval/tacos/ontology"
        self.datadir = self.cwd + '/datafiles/'
        self.indexdir = self.cwd + "/index/"

        # Any problem, comment or suggest goes send to:
        self.AdminMail='sadit@lsc.fie.umich.mx'
        #self.AdminMail='sadit@localhost'

        # Mail showed when register 
        self.RegistryMail='register@lsc.fie.umich.mx'

        self.AuthentityFile = self.datadir+"sessions.db"
        self.PasswordFile = self.datadir+"passwd.db"
        self.SpoolMailFile = self.datadir+"spool.db"

        #SMTP Server
        #SMTP_Server='jupiter.umich.mx'
        self.SMTP_Server='localhost'
        self.SMTP_Port=25

        #SPyRO Configuration
        self.SPyRO_ServerPort = 3001
        self.SPyRO_ServerAddr = '127.0.0.1'
        self.SPyRO_Server = (self.SPyRO_ServerAddr, self.SPyRO_ServerPort)
        #Servers

        # Run HTTP Server
        self.Run_HTTP = True
        self.HTTP_Root = self.root + '/webview'
        self.HTTP_CGIRoot = "/cgi-bin/" # In Web Location
        self.HTTP_CGIPath = self.HTTP_Root + self.HTTP_CGIRoot
        self.python_path.append(self.HTTP_CGIPath)
        self.HTTP_IPName = True
        weypath=os.path.join(os.path.dirname(monarca.__file__), 'wey.py')
        self.httpd_options = {
            'server_address' : ('0.0.0.0',8000),
            'DocumentRoot' : self.HTTP_Root,
            'WeyPath' : weypath,
            }
        # HTTP connections (client side)
        # Maximum retries with status 404 (not found)
        self.HTTPLib_maxRetries404 = 7
        # Maximum retries without connect remote host
        self.HTTPLib_maxRetriesHost = 16
        # Maximum redirects
        self.HTTPLib_maxRedirects = 4
        self.HTTPUserAgent = """Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.12) Gecko/20051010 Firefox/1.0.7 (Ubuntu package 1.0.7)"""
        # Template Directory (absolute or relative to CGI program CWD)
        self.TemplatePath = [ self.cwd + "/templates/" ]
        self.LanguagePath = [ self.cwd + "/lang/" ]
        self.DefaultTemplate = "uindextemplate"
        
        # Run SMTP Server 
        self.Run_SMTP = False #Not used, yet
        self.SMTP_Port = None
        
        # Index parameters
        self.IDX_replicas = 3
        
        # Pyew settings
        self.pyew_administrator = 'admin'

        #Language Settings
        self.pyewdefaults = {
            'language': 'es'
            }

        self.crawler_options = {
            }
        
        self.repository_options = {
            'root' : self.datadir,
            'poolSize' : 1,
            'mode': 0600,
            }

        self.harvest_options = {
            'harvestEvery' : 2000,
            'harvestCounterTime' : 1000,
            }

        self.realindex_options = {
            'basename' : self.indexdir,
            'cachesize' : 128 << 20,
            'poolSize' : 4,
            }

        self.index_options = {
            'poolSize' : 4,
            }

        # Distributors
        self.indexDistributorType = "Random"
        self.indexDistributorOptions = { 'spread' : True }
#         self.indexRouterType = "Local"
#         self.indexRouterOptions = { }
#         self.indexrouter = None
        
        self.harvestcallbackDistributorType = "Random"
        self.harvestcallbackDistributorOptions = { 'spread' : True , 'poolSize' : 4}
        self.harvestcallbackRouterType = "Routing"
        self.harvestcallbackRouterOptions = {}
        
        self.repositoryDistributorType = "Random"
        self.repositoryDistributorOptions = { 'spread' : True , 'poolSize' : 4}
        self.repositoryRouterType = "Routing"
        self.repositoryRouterOptions = {}

        # modules
        self.initModuleGlobal = True
        self.initModuleHarvest = True
        self.initModuleCrawler = True
        self.initModuleIndexer = True
        # Use psyco is a suggested behaviour, may cause memory leaks
        self.usePsyco = True

        # names by default
        self.name_index = 'index'
        self.name_realindex = 'realindex'
        self.name_routerindex = 'routerindex'
        #self.name_HarvestCallback = 'HarvestCallback'
        self.name_HarvestCallbackRouter = 'HarvestCallbackRouter'
        #self.name_RepositoryDistributor = 'RepositoryDistributor'
        self.name_RepositoryRouter = "RepositoryRouter"
        self.name_Repository = 'Repository'
        self.name_Harvest = 'Harvest'
        self.name_Sendmail = "Sendmail"
        self.name_Authority = "Authority"
        self.name_Passwd = "Passwd"
        self.name_TemplateCache = "TemplateCache"
        self.name_LanguageCache = "LanguageCache"
                                                                              
class MonolithicApplication:
    def __init__(self, config):
        self.config = config

    def create_distributor(self, disttype, distoptions):
        dist = getattr(distributor, disttype)
        return dist(**distoptions)

    def create_router(self, routertype, routeroptions, dist):
        rtr = getattr(router, routertype)
        return rtr(dist, **routeroptions)
        
    def crawler_init(self):
        self.crawler = Crawler.Crawler(self.harvest, **self.config.crawler_options)
        if self.config.initModuleHarvest:
            self.distcallback.register(router.Local(None, self.crawler), None)
            
    def crawler_close(self):
        pass
        
    def indexer_init(self):
        config = self.config
        self.distindexer = self.create_distributor(self.config.indexDistributorType,
                                                   self.config.indexDistributorOptions)
        # self.indexrouter = self.create_router(config.indexRouterType, config.indexRouterOptions, self.distindexer)
        self.indexrouter = spydihub.IndexRouter(self.distindexer)
        self.index = spydihub.IdxControl(self.indexrouter, **config.index_options)
        if self.config.initModuleHarvest:
            self.distcallback.register(router.Local(None, self.index), None)
        self.realindex = spydex.spydex(repositoryrouter = self.repositoryrouter,
                                       **config.realindex_options)
        self.spyro.setobj(self.config.name_index, self.index)
        self.spyro.setobj(self.config.name_routerindex, self.indexrouter)
        self.spyro.setobj(self.config.name_realindex, self.realindex)
        self.index.regindexer(router.Local(None, self.realindex))

    def indexer_close(self):
        self.distindexer.close()
        self.index.close()
        self.realindex.close()

    def harvest_init(self):
        #global distcallback, distrepository, repository, harvest
        config = self.config
        self.distcallback = self.create_distributor(self.config.harvestcallbackDistributorType,
                                                    self.config.harvestcallbackDistributorOptions)
        self.callbackrouter = self.create_router(config.harvestcallbackRouterType,
                                                 config.harvestcallbackRouterOptions, self.distcallback)

        self.distrepository = self.create_distributor(self.config.repositoryDistributorType,
                                                      self.config.repositoryDistributorOptions)
        self.repositoryrouter = self.create_router(config.repositoryRouterType,
                                                   config.repositoryRouterOptions, self.distrepository)

        self.repository = Repository(callback=self.callbackrouter,
                                     **config.repository_options)
        self.distrepository.register(router.Local(None, self.repository), None)
        # self.harvest = Harvest(self.distrepository, **config.harvest_options)
        self.harvest = Harvest(self.repositoryrouter, **config.harvest_options)
        self.distcallback.register(router.Local(None, self.harvest), None)
        self.spyro.setobj(self.config.name_HarvestCallbackRouter, self.callbackrouter)
        self.spyro.setobj(self.config.name_RepositoryRouter, self.repositoryrouter)
        self.spyro.setobj(self.config.name_Repository, self.repository)
        self.spyro.setobj(self.config.name_Harvest, self.harvest)

    def harvest_close(self):
        #global distcallback, distrepository, repository, harvest
        self.distcallback.close()
        self.distrepository.close()
        self.repository.close()
        self.harvest.close()

    def global_init(self):
        #global serv, auth, user, sendmail, temp, mesgcache
        config = self.config
        self.serv=ServerInThread(spyro.CommunicationServer, config.SPyRO_Server)
        self.spyro = self.serv.server
        self.auth=session.Authority(config.AuthentityFile)
        self.user=session.User(config.PasswordFile)
        self.sendmail=Sendmail(config.SMTP_Server, config.SMTP_Port,
                               config.SpoolMailFile)
        self.spyro.setobj(self.config.name_Sendmail, self.sendmail)
        self.spyro.setobj(self.config.name_Authority, self.auth)
        self.spyro.setobj(self.config.name_Passwd, self.user)
        
        self.temp=template.TemplateCache(config.TemplatePath, makeCode=True, makeCompiled = True)
        self.mesgcache=template.LanguageCache(config.LanguagePath)
        self.spyro.setobj(self.config.name_TemplateCache,self.temp)
        self.spyro.setobj(self.config.name_LanguageCache,self.mesgcache)

    def global_close(self):
        #global serv, auth, user, sendmail, temp, mesgcache
        self.user.close()
        self.auth.close()
        self.sendmail.close()
        self.serv.close()


    def init(self):
        config = self.config
        if config.initModuleGlobal:
            self.global_init()
        if config.initModuleHarvest:
            self.harvest_init()
        if config.initModuleCrawler:
            self.crawler_init()
        if config.initModuleIndexer:
            self.indexer_init()
        self.httpd = None

    def run(self):
        config = self.config
        if config.Run_HTTP:
            globalvars = {
                'config' : config,
                'authorization' : self.auth,
                'passwd': self.user,
                'templates': self.temp,
                'language': self.mesgcache,
                }
            self.httpd = monarca.Monarca(config = config, globalvars = globalvars,
                                         **config.httpd_options)
            self.httpd.serve_forever()
        else:
            time.sleep(1<<30 | ((1<<30)-1))

    def close(self):
        close_list = []
        config = self.config
        if config.initModuleGlobal:
            close_list.append(self.global_close)
        if config.initModuleHarvest:
            close_list.append(self.harvest_close)
        if config.initModuleCrawler:
            close_list.append(self.crawler_close)
        if config.initModuleIndexer:
            close_list.append(self.indexer_close)
        for close_function in close_list:
            try:
                close_function()
            except:
                warn.warn("Error in close function " + repr(close_function))

if __name__ == '__main__':
    conf = ConfigTemplate("/home/sadit/3kong/spydi/SPyDI/",
                          "/home/sadit/3kong/spydi/SPyDI/apps/photo-share")
    s = SPyDI(conf)
    try:
        s.init()
        s.run()
        s.close()
    except:
        warn.warn()
        s.close()


