#!/usr/bin/python
#coding: utf8;

############################################################################
#                                                                          #
#    This file 'mime/createmimetypes.py'
#    is part of 'SPyDI: Simple Python Distributed Indexing                 #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

__doc__ = "Creates the mime type (pythonized) database "

if __name__ == '__main__':
    import sre, sys
    exttomime = {}
    variables = {}
    for line in file("mime.types").readlines():
        if line.startswith(r"#"): continue
        s = sre.findall(r"\S+",line)
        if len(s) < 2: continue
        mimetype = s.pop(0)
        mimemajor = sre.split(r"/",mimetype)[0]
        variables[mimetype] = "_" + sre.sub("\W","_",mimetype)
        variables[mimemajor] = "_" + sre.sub("\W","_",mimemajor)
        for m in s:
            exttomime[m] = (variables[mimetype],variables[mimemajor])

    for value,name in variables.items():
        print "%s='%s'"%(name,value)
        #print exttomime
    print "mimes = {"
    for ext, value in exttomime.items():
        print "'%s': (%s,%s)," %(ext, value[0],value[1])
    print "}"
    sys.exit(0)

