# coding: iso-8859-1;
__doc__ = """
Python Enlightened Webpages.

This module define useful functions to fast develop of python
CGIs.

In conjunction with the "wey" system we can create html embedded style
python CGIs. A no Embedded Style is supported too.

"""

import os,sys

#sys.path.insert(0,os.path.dirname(os.path.dirname(sys.path[0])))
#sys.path.insert(0,os.path.dirname(sys.path[0]))

import cgi
import session
import SPyRO as spyro
import template
import webpage
import Cookie
#import config
import urllib
import warn

# NOTE: (I don't remember if...)
# imported variables not will be changed with this functions
# because every import * copy references, so it will not change
# when the module variables change and vice-versa.

class PageRequest:
    def __init__(self, input, output, environ,
                 authorization = None, passwd = None, templates = None,
                 language = None, config = None, spyro_server_address = None,
                 authobj = None):
        if not spyro_server_address: spyro_server_address = config.SPyRO_Server
        self.serv = serv = spyro.TClient(spyro_server_address,"/SPyRO?PICKLE2")
        # Authorization Objects
        if authorization is None:
            self.authorization = self.serv.getobj(config.name_Authority,
                                                  authobj)
        else:
            self.authorization = authorization
        if passwd is None:
            self.passwd = serv.getobj(config.name_Passwd, authobj)
        else:
            self.passwd = passwd
        # Caches
        if templates is None:
            self.templates = self.serv.getobj(config.name_TemplateCache,
                                              authobj)
        else:
            self.templates = templates
        if language is None:
            self.language = self.serv.getobj(config.name_LanguageCache,
                                             authobj)
        else:
            self.language = language
        self.authobj = None
        self.webpage = webpage.webpage(output=output)
        self.environ = environ
        self.forms = cgi.FieldStorage(fp=input,environ=environ)
	## Specific data to any environment (CGI, or sHTTP (python
	# scripting module))
        port = self.environ['SERVER_PORT']
        if port == '80':
            port = ''
        else:
            port = ':' + port
        self.serverurl = 'http://' + self.environ['SERVER_NAME'] + port
        self.thisScript = '%s%s'%(self.serverurl,self.environ['SCRIPT_NAME'])
        self.dirScript = os.path.dirname(self.thisScript)
        # modules
        self.os = os
        self.sys = sys
        self.spyro = spyro
        self.config = config
        self.warn = warn
        # Other variables
        self.field_session="4de60660c5a2cweldkksdaX0b231xKezf1g"
        self.field_user="ol550xs93x99s00x0x0assd23kcklsllsdoods"
        self.field_page="2d3938acd5315cb1d28feb6c991d09ullnb926"

    def __joindict(self, x):
        return "%s=%s"%(x[0],x[1])

    def linkself(self, options=None):
        """ Returns the URL of this script, options must be a dictionary with
        key-values to pass it to the script or None if no options needed"""
        return self.linkscript(self.thisScript, options, True)

    def linkscript(self, name, options=None, absoluteName=False):
        """ Returns the URL of the script named |name|, options must be a
        dictionary with with key-values to pass it to the script  or None
        if no options needed"""
        if options == None:
            options = {'language': self.get('language')}
        elif not options.has_key('language'):
            options['language'] = self.get('language')
        if absoluteName:
            script = name
        else:
            script = "%s/%s"%(self.dirScript,name)
        return "%s?%s"%(script, urllib.urlencode(options))

    def get(self, name, default=None):
        """ Get a cgi variable named |name|. If doesn't exits |name| returns
        |default| (default value by key is adjusted in config.py) """
        s = None
        if default == None:
            v = self.forms.getvalue(name,'')
            d = self.config.pyewdefaults.get(name, None)
            if v == '' and d:
                s = d
            else:
                s = v
        else:
            s = self.forms.getvalue(name,default)
        return s

    def _close(self):
        """ Close the pyew variables """
        self.serv.close()

    def _template(self, tempname, globalvars, localvars):
        """ Call and execute a template |template| with global variables
        |globalvars| and local variables |localvars| (see exec)"""
        temp = self.templates.get(tempname)
        return temp.execute(globalvars, localvars)

    def addheader(self, header, value):
        self.webpage[header] = value

    def template(self, tempname, globalvars, localvars):
        return self._template(tempname + '.html', globalvars, localvars)

    def send(self, page):
        """ Send a page to the browser """
        self.webpage.commit(page)
        self._close()

    def createauth(self):
        self.authobj = Auth(self)
        
    def authorize(self, strictuser=None):
        if not self.authobj: self.authobj = Auth(self)
        return self.authobj.authorize(strictuser)

    def authpasswd(self, login, password):
        if not self.authobj: self.authobj = Auth(self)
        return self.authobj.authpasswd(login, password)

    def newsession(self, login):
        """ Create a new session to login"""
        sess = session.Session()
        p = self
        c = p.webpage.cookies
        sessid = p.authorization.regsession(sess, login)
        c[p.field_session] = sessid
        dirname=os.path.dirname(p.environ['SCRIPT_NAME'])
        c[p.field_session]['path'] = dirname
        c[p.field_user] = login
        c[p.field_user]['path'] = dirname

    def delsession(self, login = None):
        """ Delete a sessin"""
        if not login: login = self.authobj.login
        p = self
        c = p.webpage.cookies
        del p.authorization[self.authobj.sessid]
        c[p.field_session] = ''
        dirname=os.path.dirname(p.environ['SCRIPT_NAME'])
        c[p.field_session]['path'] = dirname
        c[p.field_user] = ''
        c[p.field_user]['path'] = dirname

class Auth:
    def __init__(self, reqpyew):
        self.reqpyew = reqpyew
        self.login = None
        self.email = None
        self.sessid = None
        self.username = None
        self.sessauth = None

    def getent(self, login):
        ent = self.reqpyew.passwd.get(login)
        if ent:
            die, self.username, self.email = ent
            ent = None

    def authpasswd(self, login, password):
        """ Authorize a login with password"""
        if self.reqpyew.passwd.authorize(login, password):
            self.reqpyew.newsession(login)
            return True
        else:
            return False

    def authorize(self, strictusername):
        """ Returns True if the session has a correct authorization and login.
        If |strictusername| != None then the LOGIN in the authorized session
        must be |strictusername| """
        if strictusername and strictusername != self.login: return False
        if self.sessauth: return True
        p = self.reqpyew
        login = p.get(p.field_user, None)
        sessid = None

        if login:
            sessid = p.get(p.field_session, None)
        elif p.environ.has_key('HTTP_COOKIE'):
            cookie = Cookie.SimpleCookie()
            cookie.load(p.environ['HTTP_COOKIE'])
            login = cookie.get(p.field_user)
            sessid = cookie.get(p.field_session)
            if login:
                login, sessid = login.value, sessid.value
        
        if login and sessid and p.authorization.authorize(sessid, login):
            p.newsession(login)
            self.sessid = sessid
            self.sessauth = True
            self.login = login
            return True
        else:
            return False


