#coding: iso-8859-1;
############################################################################
#                                                                          #
#    This file 'webpage.py'
#    is part of 'SPyDI: Simple Python Distributed Indexing'                #
#    Copyright (C) 2004-2005 by Eric Sadit Tllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

import os, sys
import Cookie

endOfLine="\r\n"

class webpage(dict):
    def __init__(self, content='text/html', output=sys.stdout):
        self.output = output
        self['Content-Type'] = content
        self.cookies = Cookie.SimpleCookie()
        self.isdone = False

    def echo(self, *args):
        self.output.write(" ".join(map(str,args)))
    
    def sendheaders(self):
        if not self.has_key('Connection'):
            self['Connection'] = 'close'
        for k,v in self.items():
            self.output.write("%s: %s%s"%(k,v,endOfLine))
        cookies = self.cookies.output()
        if cookies == "":
            self.output.write(endOfLine)
        else:
            self.output.write(cookies)
            self.output.write(endOfLine + endOfLine)

    def commit(self, string):
        if self.isdone: return
        if not self.has_key('Content-Length'):
            self['Content-Length'] = len(string)
        self.sendheaders()
        self.output.write(string)
        self.output.flush()
