#!/usr/bin/python
#coding: utf8;
############################################################################
#                                                                          #
#    This file 'setup.py'                                                  #
#    is part of 'SPyRO: Simple Python Distributed Indexing'                #
#    Copyright (C) 2004-2005 by Eric Sadit Téllez Avila                    #
#    Copyright (C) 2006      by Eric Sadit Téllez Avila                    #
#    sadit@lsc.fie.umich.mx or donsadit@gmail.com                          #
#                                                                          #
#    This program is free software; you can redistribute it and#or modify  #
#    it under the terms of the GNU General Public License as published by  #
#    the Free Software Foundation; either version 2 of the License, or     #
#    (at your option) any later version.                                   #
#                                                                          #
#    This program is distributed in the hope that it will be useful,       #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#    GNU General Public License for more details.                          #
#                                                                          #
#    You should have received a copy of the GNU General Public License     #
#    along with this program; if not, write to the                         #
#    Free Software Foundation, Inc.,                                       #
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             #
############################################################################

from distutils.core import setup
from distutils.extension import Extension
import sys

setup(
    name="SPyDI",
    version="0.9.7",
    author="Eric Sadit Tellez Avila",
    author_email="sadit@lsc.fie.umich.mx",
    url="http://www.spyron.org/",
    license="GPL",
    platforms=["POSIX","any"],
    classifiers=["Development Status :: 4 - Beta",
     "License :: OSI Approved :: GNU General Public License (GPL)",
     "Programming Language :: Python",
     "Topic :: Internet :: WWW/HTTP :: Indexing/Search",
	"Topic :: Internet :: WWW/HTTP :: HTTP Servers",
	"Topic :: Internet :: WWW/HTTP :: Dynamic Content",
	"Topic :: Software Development :: Libraries :: Python Modules"],
    description = "SPyDI: Simple Python Distributed Indexing",
    long_description="""
    SPyDI Is a powerful engine to create distributed full text indexing systems
    and distributed search engines. It supports harvesting, crawling 
    (pull mehtods), and push methods (via a Web interface or SPyRO Web services).
    It supports boolean and vector Information retrieval models. 
    It has few dependencies, and comes with its own HTTP server and HTML embedded
    pages language (called pyew and wey pages), and session manager. It can use
    the SMTP of the Python library. It supports replacing the default modules
    with some better modules (Apache, exim, etc).


    Release notes:

    Monarca updates to support SPyRO new HTTP protocol management
    Some bug fixes in pyew pages
    General code cleanup
    """,
    #py_modules=['Harvest','Repository'],
)

print "You must enter to ./libs directory and do 'python setup.py install' to finish the install process"
